--[[---------------------------------------------------------------
                       CrazyLua
-------------------------------------------------------------------
    Half-Life   .
 LuaSocket.

: CrazyVirus
:  http://crazyvirus.net.ru
--]]----------------------------------------------------------------

query = '\255\255\255\255TSource Engine Query\0'
socket = require("socket.core")

function ExtractString(data, n)
  for i = n,#data do
    if data:sub(i, i) == '\0' then
      return i+1, data:sub(n, i-1)
    end
  end
end

function ExtractPort(data)
  for i = 1,#data do
    if data:sub(i, i) == ':' then
      return data:sub(i+1)
    end
  end
  return 27015
end

function ExtractHost(data)
  for i = 1,#data do
    if data:sub(i, i) == ':' then
      return data:sub(1, i-1)
    end
  end
  return data
end

function OnChannelMsg(Name, IP, Ch, Text)
  if Text:sub(1, 7)=='/luahl ' then
    local host = Text:sub(8)

    udp = socket.udp()
    udp:settimeout(0.5)

    local res, err = udp:setpeername(ExtractHost(host), ExtractPort(host))
    
    if res ~= nil then
      res, err = udp:send(query)
      if res ~= nil then
        res, err = udp:receive()
        if res ~= nil then    
          local n,sname,smap,pl,plt,pass = 1,nil,nil,0,0,false
        
          if res:sub(1, 5) == '\255\255\255\255I' then
            res = res:sub(7)       

            n,sname = ExtractString(res, n)
            n,smap = ExtractString(res, n)
            n = ExtractString(res, n)
            n = ExtractString(res, n)
            n = n + 2
            pl = res:byte(n, n)
            n = n + 1
            plt = res:byte(n, n)
            n = n + 4
            pass = res:byte(n, n) == 1

            SendChannelMsg(Ch, string.format('  -  %s - %s - %d/%d', sname, smap, pl, plt), true)
          elseif res:sub(1, 5) == '\255\255\255\255m' then
            res = res:sub(6)

            n = ExtractString(res, n)
            n,sname = ExtractString(res, n)
            n,smap = ExtractString(res, n)    
            n = ExtractString(res, n)
            n = ExtractString(res, n)
            pl = res:byte(n, n)
            n = n + 1
            plt = res:byte(n, n)
            n = n + 4
            pass = res:byte(n, n) == 1

            SendChannelMsg(Ch, string.format('  -  %s - %s - %d/%d', sname, smap, pl, plt), true)
          end
        else
          AddEvent(0, true, false, 'recv err: '..err)
        end  
      else
        AddEvent(0, true, false, 'send err: '..err)
      end  
    else
      AddEvent(0, true, false, 'setpeername err: '..err)
    end      
    udp:close()
  end
end